static char rcsid[] = "$Header: autoconf.c,v 10.1 86/07/21 14:56:13 bog Exp $";
static char sccsid[]="%W% %Y% %Q% %G%";

/************************************************************************
*									*
*				Copyright 1984				*
*			VALID LOGIC SYSTEMS INCORPORATED		*
*									*
*	This listing contains confidential proprietary information	*
*	which is not to be disclosed to unauthorized persons without	*
*	written consent of an officer of Valid Logic Systems 		*
*	Incorporated.							*
*									*
*	The copyright notice appearing above is included to provide	*
*	statutory protection in the event of unauthorized or 		*
*	unintentional public disclosure.				*
*									*
************************************************************************/

/*
 *
 * Autoconf.c - autoconfiguration routines (the UNIX concept)
 *
 * Setup the system to run on the current machine.
 *
 * Configure() is called at boot time to initialize the multibus
 * device tables.  Available devices are determined (from possibilities
 * mentioned in ioconf.c), and the drivers are initialized.
 */

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/buf.h"
#include "../h/dk.h"
#include "../h/vm.h"
#include "../h/conf.h"
#include "../h/dmap.h"

#include "../s32/cpu.h"
#include "../s32/trap.h"
#include "../s32dev/mbvar.h"

/*
 * The following several variables are related to
 * the configuration process, and are used in initializing
 * the machine.
 *
 * Cvec is the interrupt auto-vector number set in mbint?() when
 * we probe a controller.  Unlike the Vax, we don't fool around
 * with returning values in registers.
 */

/*
 * Determine mass storage and memory configuration for a machine.
 *
 * This routine is meant to emulate UNIX's way of probing for all devices
 * around at boot time, so the program knows what it has.
 *
 * Since the standalone things don't autoconfigure, yet,
 * this routine does nothing.
 */
configure()
{
	return;
}
