static char rcsid[] = "$Header: tty_conf.c,v 820.1 86/12/04 19:58:57 root Exp $";
static char sccsid[]="%W% %Y% %Q% %G%";

/************************************************************************
*									*
*				Copyright 1984				*
*			VALID LOGIC SYSTEMS INCORPORATED		*
*									*
*	This listing contains confidential proprietary information	*
*	which is not to be disclosed to unauthorized persons without	*
*	written consent of an officer of Valid Logic Systems 		*
*	Incorporated.							*
*									*
*	The copyright notice appearing above is included to provide	*
*	statutory protection in the event of unauthorized or 		*
*	unintentional public disclosure.				*
*									*
************************************************************************/

/*	tty_conf.c	6.2	83/09/25	*/

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/buf.h"
#include "../h/tty.h"
#include "../h/conf.h"

int	nodev();
int	nulldev();

int	ttyopen(),ttyclose(),ttread(),ttwrite(),nullioctl(),ttstart();
int	ttyinput();

#include "bk.h"
#if NBK > 0
int	bkopen(),bkclose(),bkread(),bkinput(),bkioctl();
#endif

#include "tb.h"
#if NTB > 0
int	tbopen(),tbclose(),tbread(),tbinput(),tbioctl();
#endif

#ifdef WHITE
int	mouse_input();
#endif WHITE

struct	linesw linesw[] =
{
	{ ttyopen, nulldev, ttread, ttwrite, nullioctl,
	ttyinput, nodev, nulldev, ttstart, nulldev },		/* OTTYDISC==0*/
#if NBK > 0
	{ bkopen, bkclose, bkread, ttwrite, bkioctl,
	bkinput, nodev, nulldev, ttstart, nulldev },		/* NETLDISC==1*/
#else
	{ nodev, nodev, nodev, nodev, nodev,
	nodev, nodev, nodev, nodev, nodev },
#endif
	{ ttyopen, ttyclose, ttread, ttwrite, nullioctl,
	ttyinput, nodev, nulldev, ttstart, nulldev },		/* NTTYDISC==2*/
#if NTB > 0
	{ tbopen, tbclose, tbread, nodev, tbioctl,
	tbinput, nodev, nulldev, ttstart, nulldev },		/* 3 */
#else
	{ nodev, nodev, nodev, nodev, nodev,
	nodev, nodev, nodev, nodev, nodev },
#endif
#if NTB > 0
	{ tbopen, tbclose, tbread, nodev, tbioctl,
	tbinput, nodev, nulldev, ttstart, nulldev },		/* 4 */
#else
	{ nodev, nodev, nodev, nodev, nodev,
	nodev, nodev, nodev, nodev, nodev },
#endif
#ifdef WHITE
	{ nodev, nodev, nodev, nodev, nodev,
	mouse_input, nodev, nulldev, nodev, nulldev },		/* 5 */
#else WHITE
	{ nodev, nodev, nodev, nodev, nodev,
	nodev, nodev, nodev, nodev, nodev },
#endif WHITE
};

int	nldisp = sizeof (linesw) / sizeof (linesw[0]);

/*
 * Do nothing specific version of line
 * discipline specific ioctl command.
 */
/*ARGSUSED*/
nullioctl(tp, cmd, data, flags)
	struct tty *tp;
	char *data;
	int flags;
{

#ifdef lint
	tp = tp; data = data; flags = flags;
#endif
	return (-1);
}
