/* rcsid[]="$Header: vnet_ioctl.h,v 800.0 85/08/06 14:04:31 root Exp $" */
/* sccsid[]="%W% %Y% %Q% %G%" */

/************************************************************************
*									*
*				Copyright 1985				*
*			VALID LOGIC SYSTEMS INCORPORATED		*
*									*
*	This listing contains confidential proprietary information	*
*	which is not to be disclosed to unauthorized persons without	*
*	written consent of an officer of Valid Logic Systems 		*
*	Incorporated.							*
*									*
*	The copyright notice appearing above is included to provide	*
*	statutory protection in the event of unauthorized or 		*
*	unintentional public disclosure.				*
*									*
************************************************************************/

/*
 * i/o controls for VALIDnet
 *
 * sas 850423
 * sas 850605 -- Added BULK data support.
 * jht 850607 -- Added comments, history and new ioctl selector for VNET.
 */

#define VNETIOC_SET	_IOW(_IO_VNET, 1, struct vnetconf)

/*
 * This structure is used to configure the VALIDnet interfaces.
 *
 * ifconn -- the interface used by the CONN protocol
 * ifrpc -- the interface used by the RPC protocol
 * ifbulk -- the interface used by the BULK (data) protocol
 *
 * It would be silly if these interfaces were to different
 * physical connections.
 */
struct vnetconf {
	char ifconnname[IFNAMSIZ];
	char ifrpcname[IFNAMSIZ];
	char ifbulkname[IFNAMSIZ];
};
